exports.loadDefaultTypeConverters = function(context){
	var stringConverter = function(value, inputType) { return new String(value) };
	context.registerTypeConversion("xsd:string", stringConverter);
	var booleanConverter = function(value, inputType) { switch(value){case "false":case "0":return false;} return(new Boolean(value)).valueOf() };
	context.registerTypeConversion("xsd:boolean", booleanConverter);
	var numberConverter = function(value, inputType) { return(new Number(value)).valueOf() };
	context.registerTypeConversion("xsd:float", numberConverter);
	context.registerTypeConversion("xsd:integer", numberConverter);
	context.registerTypeConversion("xsd:long", numberConverter);
	context.registerTypeConversion("xsd:double", numberConverter);
	context.registerTypeConversion("xsd:decimal", numberConverter);
	context.registerTypeConversion("xsd:nonPositiveInteger", numberConverter);
	context.registerTypeConversion("xsd:nonNegativeInteger", numberConverter);
	context.registerTypeConversion("xsd:negativeInteger", numberConverter);
	context.registerTypeConversion("xsd:int", numberConverter);
	context.registerTypeConversion("xsd:unsignedLong", numberConverter);
	context.registerTypeConversion("xsd:positiveInteger", numberConverter);
	context.registerTypeConversion("xsd:short", numberConverter);
	context.registerTypeConversion("xsd:unsignedInt", numberConverter);
	context.registerTypeConversion("xsd:byte", numberConverter);
	context.registerTypeConversion("xsd:unsignedShort", numberConverter);
	context.registerTypeConversion("xsd:unsignedByte", numberConverter);
	var dateConverter = function(value, inputType) { return new Date(value) };
	context.registerTypeConversion("xsd:date", dateConverter);
	context.registerTypeConversion("xsd:time", dateConverter);
	context.registerTypeConversion("xsd:dateTime", dateConverter);
};
exports.loadDefaultPrefixMap = function(context){
	context.setMapping("owl", "http://www.w3.org/2002/07/owl#");
	context.setMapping("rdf", "http://www.w3.org/1999/02/22-rdf-syntax-ns#");
	context.setMapping("rdfs", "http://www.w3.org/2000/01/rdf-schema#");
	context.setMapping("rdfa", "http://www.w3.org/ns/rdfa#");
	context.setMapping("xhv", "http://www.w3.org/1999/xhtml/vocab#");
	context.setMapping("xml", "http://www.w3.org/XML/1998/namespace");
	context.setMapping("xsd", "http://www.w3.org/2001/XMLSchema#");
	context.setMapping("grddl", "http://www.w3.org/2003/g/data-view#");
	context.setMapping("powder", "http://www.w3.org/2007/05/powder#");
	context.setMapping("powders", "http://www.w3.org/2007/05/powder-s#");
	context.setMapping("rif", "http://www.w3.org/2007/rif#");
	context.setMapping("atom", "http://www.w3.org/2005/Atom/");
	context.setMapping("xhtml", "http://www.w3.org/1999/xhtml#");
	context.setMapping("formats", "http://www.w3.org/ns/formats/");
	context.setMapping("xforms", "http://www.w3.org/2002/xforms/");
	context.setMapping("xhtmlvocab", "http://www.w3.org/1999/xhtml/vocab/");
	context.setMapping("xpathfn", "http://www.w3.org/2005/xpath-functions#");
	context.setMapping("http", "http://www.w3.org/2006/http#");
	context.setMapping("link", "http://www.w3.org/2006/link#");
	context.setMapping("time", "http://www.w3.org/2006/time#");
	context.setMapping("acl", "http://www.w3.org/ns/auth/acl#");
	context.setMapping("cert", "http://www.w3.org/ns/auth/cert#");
	context.setMapping("rsa", "http://www.w3.org/ns/auth/rsa#");
	context.setMapping("crypto", "http://www.w3.org/2000/10/swap/crypto#");
	context.setMapping("list", "http://www.w3.org/2000/10/swap/list#");
	context.setMapping("log", "http://www.w3.org/2000/10/swap/log#");
	context.setMapping("math", "http://www.w3.org/2000/10/swap/math#");
	context.setMapping("os", "http://www.w3.org/2000/10/swap/os#");
	context.setMapping("string", "http://www.w3.org/2000/10/swap/string#");
	context.setMapping("doc", "http://www.w3.org/2000/10/swap/pim/doc#");
	context.setMapping("contact", "http://www.w3.org/2000/10/swap/pim/contact#");
	context.setMapping("p3p", "http://www.w3.org/2002/01/p3prdfv1#");
	context.setMapping("swrl", "http://www.w3.org/2003/11/swrl#");
	context.setMapping("swrlb", "http://www.w3.org/2003/11/swrlb#");
	context.setMapping("exif", "http://www.w3.org/2003/12/exif/ns#");
	context.setMapping("earl", "http://www.w3.org/ns/earl#");
	context.setMapping("ma", "http://www.w3.org/ns/ma-ont#");
	context.setMapping("sawsdl", "http://www.w3.org/ns/sawsdl#");
	context.setMapping("sd", "http://www.w3.org/ns/sparql-service-description#");
	context.setMapping("skos", "http://www.w3.org/2004/02/skos/core#");
	context.setMapping("fresnel", "http://www.w3.org/2004/09/fresnel#");
	context.setMapping("gen", "http://www.w3.org/2006/gen/ont#");
	context.setMapping("timezone", "http://www.w3.org/2006/timezone#");
	context.setMapping("skosxl", "http://www.w3.org/2008/05/skos-xl#");
	context.setMapping("org", "http://www.w3.org/ns/org#");
	context.setMapping("ical", "http://www.w3.org/2002/12/cal/ical#");
	context.setMapping("wgs84", "http://www.w3.org/2003/01/geo/wgs84_pos#");
	context.setMapping("vcard", "http://www.w3.org/2006/vcard/ns#");
	context.setMapping("turtle", "http://www.w3.org/2008/turtle#");
	context.setMapping("pointers", "http://www.w3.org/2009/pointers#");
	context.setMapping("dcat", "http://www.w3.org/ns/dcat#");
	context.setMapping("imreg", "http://www.w3.org/2004/02/image-regions#");
	context.setMapping("rdfg", "http://www.w3.org/2004/03/trix/rdfg-1/");
	context.setMapping("swp", "http://www.w3.org/2004/03/trix/swp-2/");
	context.setMapping("rei", "http://www.w3.org/2004/06/rei#");
	context.setMapping("wairole", "http://www.w3.org/2005/01/wai-rdf/GUIRoleTaxonomy#");
	context.setMapping("states", "http://www.w3.org/2005/07/aaa#");
	context.setMapping("wn20schema", "http://www.w3.org/2006/03/wn/wn20/schema/");
	context.setMapping("httph", "http://www.w3.org/2007/ont/httph#");
	context.setMapping("act", "http://www.w3.org/2007/rif-builtin-action#");
	context.setMapping("common", "http://www.w3.org/2007/uwa/context/common.owl#");
	context.setMapping("dcn", "http://www.w3.org/2007/uwa/context/deliverycontext.owl#");
	context.setMapping("hard", "http://www.w3.org/2007/uwa/context/hardware.owl#");
	context.setMapping("java", "http://www.w3.org/2007/uwa/context/java.owl#");
	context.setMapping("loc", "http://www.w3.org/2007/uwa/context/location.owl#");
	context.setMapping("net", "http://www.w3.org/2007/uwa/context/network.owl#");
	context.setMapping("push", "http://www.w3.org/2007/uwa/context/push.owl#");
	context.setMapping("soft", "http://www.w3.org/2007/uwa/context/software.owl#");
	context.setMapping("web", "http://www.w3.org/2007/uwa/context/web.owl#");
	context.setMapping("content", "http://www.w3.org/2008/content#");
	context.setMapping("vs", "http://www.w3.org/2003/06/sw-vocab-status/ns#");
	context.setMapping("air", "http://dig.csail.mit.edu/TAMI/2007/amord/air#");
	context.setMapping("ex", "http://example.org/");
	context.setMapping("dc", "http://purl.org/dc/terms/");
	context.setMapping("dc11", "http://purl.org/dc/elements/1.1/");
	context.setMapping("dctype", "http://purl.org/dc/dcmitype/");
	context.setMapping("foaf", "http://xmlns.com/foaf/0.1/");
	context.setMapping("cc", "http://creativecommons.org/ns#");
	context.setMapping("opensearch", "http://a9.com/-/spec/opensearch/1.1/");
	context.setMapping("void", "http://rdfs.org/ns/void#");
	context.setMapping("sioc", "http://rdfs.org/sioc/ns#");
	context.setMapping("sioca", "http://rdfs.org/sioc/actions#");
	context.setMapping("sioct", "http://rdfs.org/sioc/types#");
	context.setMapping("lgd", "http://linkedgeodata.org/vocabulary#");
	context.setMapping("moat", "http://moat-project.org/ns#");
	context.setMapping("days", "http://ontologi.es/days#");
	context.setMapping("giving", "http://ontologi.es/giving#");
	context.setMapping("lang", "http://ontologi.es/lang/core#");
	context.setMapping("like", "http://ontologi.es/like#");
	context.setMapping("status", "http://ontologi.es/status#");
	context.setMapping("og", "http://opengraphprotocol.org/schema/");
	context.setMapping("protege", "http://protege.stanford.edu/system#");
	context.setMapping("dady", "http://purl.org/NET/dady#");
	context.setMapping("uri", "http://purl.org/NET/uri#");
	context.setMapping("audio", "http://purl.org/media/audio#");
	context.setMapping("video", "http://purl.org/media/video#");
	context.setMapping("gridworks", "http://purl.org/net/opmv/types/gridworks#");
	context.setMapping("hcterms", "http://purl.org/uF/hCard/terms/");
	context.setMapping("bio", "http://purl.org/vocab/bio/0.1/");
	context.setMapping("cs", "http://purl.org/vocab/changeset/schema#");
	context.setMapping("geographis", "http://telegraphis.net/ontology/geography/geography#");
	context.setMapping("doap", "http://usefulinc.com/ns/doap#");
	context.setMapping("daml", "http://www.daml.org/2001/03/daml+oil#");
	context.setMapping("geonames", "http://www.geonames.org/ontology#");
	context.setMapping("sesame", "http://www.openrdf.org/schema/sesame#");
	context.setMapping("cv", "http://rdfs.org/resume-rdf/");
	context.setMapping("wot", "http://xmlns.com/wot/0.1/");
	context.setMapping("media", "http://purl.org/microformat/hmedia/");
	context.setMapping("ctag", "http://commontag.org/ns#");
};
